(*
  Author: Kulverstukas
  Written on: 2011-09-08
  http://newage.ql.lt/
  ------
  Program to create lots
  of folders on your Desktop.
*)

program Foldurs;
{$APPTYPE CONSOLE}
{$R *.dres}

uses
  SysUtils;
const DefaultFolders = 100; // If nothing is given in an argument, this value is used
var Desktop : String;
    FolderCount, Folders : integer;
//==========================================
(* Generate a random name in given length of given chars *)
function RandomName : String;
const abc = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789abcdefghijklmnopqestuvwxyz';
      Name = 10;  // this number states how long will the folder name be
var Count : integer;
    NameStr : String;
begin
 for Count := 1 to Name do
  begin
    NameStr := NameStr + abc[System.Random(51)];
  end;
  Result := Trim(NameStr);
  NameStr := '';
end;
//==========================================
(* Strip crap from the string and leave only numbers *)
function PickNumbers(Line : String) : Integer;
var Ch : String;
    ChCount : integer;
begin
 for ChCount := 1 to length(Line) do
  begin
    if (Line[ChCount] in ['0'..'9']) then
    Ch := Ch + Line[ChCount];
  end;
 if (Ch = '') then Result := DefaultFolders
 else Result := StrToInt(Ch);
end;
//==========================================
begin
 if (ParamCount > 0) then
  Folders := PickNumbers(ParamStr(1))
 else Folders := DefaultFolders;
 Desktop := SysUtils.GetEnvironmentVariable('userprofile');
 Desktop := Desktop + '\Desktop';
 for FolderCount := 1 to Folders do
  begin
    SysUtils.CreateDir(Desktop+'\'+RandomName);
  end;
end.
